﻿using System;
using System.Linq;
using Dapper;
using System.Collections.Generic;
using Models;
using Syncfusion.XlsIO;
using Syncfusion.EJ.Export;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.JavaScript.Web;
using System.Collections;
using DocumentFormat.OpenXml.Office2010.ExcelAc;
using System.Web.UI.WebControls;
public partial class Workpackage_Snapshots_Treegrid : BandPage
{

    #region Sql

    private readonly string GetSnapshots = @"
                                select
                                p.Friendly_Name [snap],

                                ISNULL(t.name,'All') [Trade],
                                                                ISNULL(b.name,'All') [Billing],
                                --sum(Xm) [xm],
                                sum(Xm) [xm],
                                sum(Xs)[xs],
                                sum(s.forecast) [sales],
                                sum(Xm)+sum(xs) [combo],
                                sum(actualHrs)  [Hrs]
                                ,SUM(CAST(fL.forecast  AS int) - CAST(s.forecast AS int)) [forecastlcompare]
                                                                --,SUM(CAST(fL.forecast  AS int) - CAST(actualHrs  AS int)) [forecastlremaining]
                                                                ,SUM(CAST(ISNULL(fL.forecast,s.forecast)  AS int) - CAST(actualHrs  AS int)) [forecastlremaining]


                                from EXT_Snapshot_Workpackage_Snap s

                                LEFT JOIN EXT_Workpackage_Type t on s.Trade=t.EXT_Workpackage_Type_ID
                                LEFT JOIN EXT_Workpackage_Billing_Type b on s.Billing=b.EXT_Workpackage_Billing_Type_ID
                                LEFT JOIN EXT_Snapshot_Project_Snap p on s.EXT_Snapshot_Project_Snap_ID=p.EXT_Snapshot_Project_Snap_ID
                                LEFT JOIN EXT_Snapshot_WP_Forecast fL on s.EXT_Snapshot_Project_Snap_ID=fL.snap_id and fL.ext_workpackage_id=s.WP_ID and fL.forecast_type='L'
                                                                LEFT JOIN EXT_Snapshot_WP_Forecast fM on s.EXT_Snapshot_Project_Snap_ID=fM.snap_id and fM.ext_workpackage_id=s.WP_ID and fM.forecast_type='M'
                                where p.Project_ID=@Entity
                                                                and s.Status in (2,5)
                                group by
                                GROUPING SETS
                                (
                                    (p.friendly_name,t.name),
                                        (p.friendly_name,t.name,b.name)
                                )
                                order by ISNULL(t.name,''),b.name
";

    #endregion Sql



    public IEnumerable<WorkpackageSnapshots> GetSnapshotDetails(bool hideComplete)
    {
        using (var connection = ConnectionService.CreateConnection())
        {
            var snapshots = connection.Query<WorkpackageSnapshots>(GetSnapshots, new { Entity = Entity.EntityID, User = UserID, Parameter = Parameter });

            snapshots = snapshots.ToList();

            return snapshots;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {

        BindGrid();

    }

    private void BindGrid()
    {
        SnapshotTreegrid.DataSource = GetSnapshotDetails(false);
        SnapshotTreegrid.DataBind();
    }

    public class WorkpackageSnapshots
    {

        public string snap { get; set; }
        public string billing { get; set; }
        public string trade { get; set; }
        public int xm { get; set; }
        public int xs { get; set; }
        public int combo { get; set; }
        public int sales { get; set; }
        public int hrs { get; set; }

    }
}